// LogB.java                                        MM 2013
import Tools.IO.*;                              // Eingaben

/**
 * Logarithmusfunktion f(x) = logb( x),
 * Basis b aus R, b > 0, b >< 1,
 * D = ] 0, +unendlich[, W = R.
 * @author Monika Meiler
 */
public class LogB extends DifferenzierbareFunktion
{
/* ----------------------------------------------------- */
                                               // Attribute
/**
 * Basis b.
 */
  private double b = 2;

/* ----------------------------------------------------- */
                                             // set-Methode
/**
 * Setzt b fuer logb( x).
 * @param basis Basis b
 * @return true, bei erfolgreichem Eintrag
 *         false, b <= 0 oder b == 1
 */
  public boolean setBasis( double basis)
  {
    if( b <= 0 || b == 1) return false;
    b = basis;
    return true;
  }

/**
 * Basiseingabe ueber Konsole.
 * @return true, bei erfolgreichem Eintrag
 *         false, b <= 0 oder b == 1
 */
  public boolean konsolenEingabe()
  {
// Eingabe der Geradenkoeffizienten
    System.out.println( "Basiseingabe");

    double b = IOTools.readDouble
       ( " Basis b ( b > 0, b >< 1) = ");

    return setBasis( b);
  }

/* ----------------------------------------------------- */
                                         // service-Methode
/**
 * Berechnen eines Funktionswertes der Funktion
 * logb( x) = ln( x) / ln( b).
 * @param arg Argument
 * @return f( arg)
 */
  public double wert( double arg)
  {
// Trivialfaelle
    if( arg < 0)  return Double.NaN;
    if( arg == 0)
      if( b > 1) return Double.NEGATIVE_INFINITY;
      else return Double.POSITIVE_INFINITY;
    if( arg == 1) return 0;

// Sonst
    Ln ln = new Ln();
    return ln.wert( arg) / ln.wert( b);
  }

/**
 * Berechnen der ersten Ableitung
 * f'( x) = 1 / ( x * ln( b)).
 * @param arg Argument
 * @return f'( arg)
 */
  public double wertErsteAbleitung( double arg)
  {
// Trivialfall
    if( arg == 0) return Double.POSITIVE_INFINITY;

// Sonst
    Ln ln = new Ln();
    return 1 / (arg * ln.wert( b));
  }

/* ----------------------------------------------------- */
                                        // toString-Methode
/**
 * Darstellen der Logarithmusfunktion.
 * @return Funktion in linearer Schreibweise
 */
  public String toString()
  {
    return "log( x) zur Basis " + b;
  }
}