// RationaleFunktionNullstellen.java                MM 2013
import Tools.IO.*;                              // Eingaben

/**
 * Nullstellenberechner fr rationale Funktionen
 * mit Regula falsi,
 * Anwendung der Klasse Iteration.
 * @author Monika Meiler
 */
public class RationaleFunktionNullstellen
{
/**
 * Hauptprogramm,
 * startet Dialog zwischen Nutzer und Programm.
 */
  public static void main( String[] args)
  {
// Ueberschrift
    System.out.println();
    System.out.println( "Nullstellen rationaler Funktionen");

// Dialog
    char weiter = 'j';
    do
    {
// Neue Funktion
      System.out.println();
      RationaleFunktion f = new RationaleFunktion();
      if( f.konsolenEingabe())           // Eingabe korrekt
      {
// Funktionsausgabe
        System.out.println();
        System.out.println( "f( x) = " + f);
        System.out.println();

        do
        {
// Eingabe der Startnullstellen
          double x0
          = IOTools.readDouble( " Anfangswert x0 = ");
          System.out.println( " " + x0);

          double x1
          = IOTools.readDouble( " Anfangswert x1 = ");
          System.out.println( " " + x1);

          if( Math.signum( f.wert( x0))
              != Math.signum( f.wert( x1)))
          {
            double eps = 1e-15;              // Genauigkeit
            int max = 1000;  // Maximalzahl der Iterationen

// Newtoniteration
            Iteration it = new Iteration();
            double erg
            = it.regulaFalsi( f, x0, x1, eps, max);

            int anzahl = it.getAnzahl();
            if( anzahl == max) System.out.println
              ( " Berechnung vorzeitig abgebrochen!" +
                " Ergebnis ungenau!");

            System.out.println
            ( " Regula falsi (" + anzahl + "): " + erg);
          }
          else
          {
            System.out.println
            ( " Berechnung mit Regla falsi nur moeglich,");
            System.out.println
            ( " falls signum( f( x0)) != signum( f( x1)).");
          }
          System.out.println();

// Weiter
          weiter
          = IOTools.readChar( "Neue Anfangswerte (j/n)? ");
        } while( weiter == 'j');
      }

      System.out.println();
      weiter = IOTools.readChar( "Neue Funktion (j/n)? ");
      System.out.println();
    } while( weiter == 'j');

// Programm beendet
    System.out.println();
    System.out.println( "Programm beendet");
  }
}

/* ----------------------------------------------------- */
                                            // Testbeispiel
/*
Nullstellen rationaler Funktionen

f( x) = ( -3.0 + 7.0 x^1 + -5.0 x^2 + 1.0 x^3 ) / ( 1.0 )
Nullstelle x = 1 und x = 3
 Anfangswert x0 =  4.0
 Anfangswert x1 =  2.0
 Regula falsi (62): 2.9999999999999996               // eps

 Anfangswert x0 =  2.0
 Anfangswert x1 =  1.0
 Regula falsi (0): 1.0                 // x1 ist Nullstelle

 Anfangswert x0 =  7.0
 Anfangswert x1 =  2.0
 Berechnung vorzeitig abgebrochen! Ergebnis ungenau!
 Regula falsi (1000): 2.999999999999998              // max

 Anfangswert x0 =  1.5
 Anfangswert x1 =  2.5
 Berechnung mit Regla falsi nur moeglich,
 falls signum( f( x0)) != signum( f( x1)).           // sgn

f( x) = ( -4.0 + 0.0 x^1 + 1.0 x^2 ) / ( 1.0 )
2. Wurzel aus 4 als Nullstellenproblem
Nullstelle x = 2
 Anfangswert x0 =  1.0
 Anfangswert x1 =  4.0
 Regula falsi (33): 1.9999999999999998               // eps

f( x) = ( -6.0 + 3.0 x^1 )
      / ( 2.0 + -3.0 x^1 + 0.0 x^2 + 1.0 x^3 )
Nullstelle x = 2
 Anfangswert x0 =  1.5
 Anfangswert x1 =  2.5
 Regula falsi (138): 2.0000000000000013              // eps

 Anfangswert x0 =  -1.0
 Anfangswert x1 =  2.5
 Regula falsi (7): 2.0                               // eps

 Anfangswert x0 =  -2.5
 Anfangswert x1 =  1.5
 Regula falsi (115): NaN                             // Pol
*/
